GreyD	= Grey color=G newclip=1 title=" " titlesz=0 label1="Time (sec)" label2="Offset (km)" labelsz=10
GraphD	= Graph legend=y label1="Frequency (Hz)" label2="Log amplitude" labelsz=10 titlesz=10 plotfat=6
WinD	= Window3d min1=1.05 max1=1.3 min2=-1 max2=1.
WigglD	= ${Wiggly} label1="Time (sec)" label2="Offset (km)" labelsz=10 titlesz=10 plotfat=4
TpowD	= Tpow tpow=6
Graph2	= Graph label1="Time (sec)" label2=" " labelsz=10 titlesz=0 plotfat=6

# subsample the signature we were given from 1ms to 2ms.
# shift the signature so that the maximum energy is at time 0.
${D}/CA_%.H: ${MVDATA}/CA_%.H
	cp $< $@

${D}/CA_%_sub.H: ${D}/CA_%.H
	Interp < ${D}/CA_$*.H d1out=0.002 | Pad n1out=7501 > ${D}/CA_$*_sub.H
	echo "hff=-1" >> ${D}/CA_$*_sub.H
	Window3d < ${D}/CA_$*_sub.H min1=0 > a.H
	Window3d < ${D}/CA_$*_sub.H max1=-0.0001 > b.H
	Merge a.H b.H axis=1 space=n > ${D}/CA_$*_sub.H
	Rm a.H b.H

#=================================
# apply designature to data
${D}/microspread7.H: ${D}/microspread6.H ${D}/CA_Hyd_sub.H ${D}/CA_Geo_sub.H ${B}/desig_c2c.x
	${B}/desig_c2c.x < $< hsig=${D}/CA_Hyd_sub.H gsig=${D}/CA_Geo_sub.H delt=0.1 heps=1.25e-5. zeps=4.1e-4 xeps=7.0e-4 yeps=1.5e-3 > $@ hff=$@@@


#=======================================
# designature figures of a particular node
${D}/sig-node%.H: ${D}/microspread6.H
	Window_key < $< key1=Nodeid mink1=$* maxk1=$* key2=Offsetx mink2=-2. maxk2=2. key3=Sailline mink3=2001 maxk3=2001 synch=1 1>${D}/tmp1.H hff=${D}/tmp1.H@@ 2>${dn}
	Sort3d < ${D}/tmp1.H nkeys=1 key1=Offsetx ng1=81 og1=-2. dg1=0.05 synch=1 1> $@ hff=$@@@ gff=$@@@@@ 2>${dn}
	echo "gff=-1" >> $@
	Rm ${D}/tmp1.H

${D}/desig-node%.H: ${D}/microspread7.H
	Window_key < $< key1=Nodeid mink1=$* maxk1=$* key2=Offsetx mink2=-2. maxk2=2. key3=Sailline mink3=2001 maxk3=2001 synch=1 1>${D}/tmp1.H hff=${D}/tmp1.H@@ 2>${dn}
	Sort3d < ${D}/tmp1.H nkeys=1 key1=Offsetx ng1=81 og1=-2 dg1=0.05 synch=1 1> $@ hff=$@@@ gff=$@@@@@ 2>${dn}
	echo "gff=-1" >> $@
	Rm ${D}/tmp1.H

${D}/hmo-sig-node%.H: ${D}/sig-node%.H ${B}/hmo3d.x
	${B}/hmo3d.x < $< sdepth=${sdepth} vel=${water_vel} > $@ hff=$@@@
	
${D}/hmo-desig-node%.H: ${D}/desig-node%.H ${B}/hmo3d.x
	${B}/hmo3d.x < $< sdepth=${sdepth} vel=${water_vel} > $@ hff=$@@@
	
${R}/comp-node%: ${D}/hmo-sig-node%.H ${D}/hmo-desig-node%.H

	Window_key < ${D}/hmo-sig-node$*.H key1=Tracf mink1=4. maxk1=4. synch=1 1> ${D}/node$*hyd.H hff=${D}/node$*hyd.H@@ 2> ${dn}
	Window_key < ${D}/hmo-sig-node$*.H key1=Tracf mink1=3. maxk1=3. synch=1 1> ${D}/node$*vz.H  hff=${D}/node$*vz.H@@  2> ${dn}
	Window_key < ${D}/hmo-sig-node$*.H key1=Tracf mink1=2. maxk1=2. synch=1 1> ${D}/node$*vy.H  hff=${D}/node$*vy.H@@  2> ${dn}
	Window_key < ${D}/hmo-sig-node$*.H key1=Tracf mink1=1. maxk1=1. synch=1 1> ${D}/node$*vx.H  hff=${D}/node$*vx.H@@  2> ${dn}
	echo "hff=-1" >> ${D}/node$*hyd.H
	echo "hff=-1" >> ${D}/node$*vz.H
	echo "hff=-1" >> ${D}/node$*vy.H
	echo "hff=-1" >> ${D}/node$*vx.H
	echo "o2=-1.91 d2=0.05 n2=77" >> ${D}/node$*hyd.H
	echo "o2=-1.91 d2=0.05 n2=77" >> ${D}/node$*vz.H
	echo "o2=-1.91 d2=0.05 n2=77" >> ${D}/node$*vx.H
	echo "o2=-1.91 d2=0.05 n2=77" >> ${D}/node$*vy.H
	Rm ${D}/node$*hyd.H@@ ${D}/node$*v[xyz].H@@

	Window_key < ${D}/hmo-desig-node$*.H key1=Tracf mink1=4. maxk1=4. synch=1 1> ${D}/desig-node$*hyd.H hff=${D}/desig-node$*hyd.H@@ 2> ${dn}
	Window_key < ${D}/hmo-desig-node$*.H key1=Tracf mink1=3. maxk1=3. synch=1 1> ${D}/desig-node$*vz.H  hff=${D}/desig-node$*vz.H@@  2> ${dn}
	Window_key < ${D}/hmo-desig-node$*.H key1=Tracf mink1=2. maxk1=2. synch=1 1> ${D}/desig-node$*vy.H  hff=${D}/desig-node$*vy.H@@  2> ${dn}
	Window_key < ${D}/hmo-desig-node$*.H key1=Tracf mink1=1. maxk1=1. synch=1 1> ${D}/desig-node$*vx.H  hff=${D}/desig-node$*vx.H@@  2> ${dn}
	echo "hff=-1" >> ${D}/desig-node$*hyd.H
	echo "hff=-1" >> ${D}/desig-node$*vz.H
	echo "hff=-1" >> ${D}/desig-node$*vy.H
	echo "hff=-1" >> ${D}/desig-node$*vx.H
	echo "o2=-1.91 d2=0.05 n2=77" >> ${D}/desig-node$*hyd.H
	echo "o2=-1.91 d2=0.05 n2=77" >> ${D}/desig-node$*vz.H
	echo "o2=-1.91 d2=0.05 n2=77" >> ${D}/desig-node$*vx.H
	echo "o2=-1.91 d2=0.05 n2=77" >> ${D}/desig-node$*vy.H
	Rm ${D}/desig-node$*hyd.H@@ ${D}/desig-node$*v[xyz].H@@

	Merge ${D}/node$*hyd.H ${D}/desig-node$*hyd.H axis=3 space=n | Spectra | Stack | Window3d max1=15 | Log | ${GraphD} title="Hydrophone" curvelabel="node $* hydrophone before desig:node $* hydrophone after desig" out=$@-hyd-f1.v > ${dn}
	Merge ${D}/node$*hyd.H ${D}/desig-node$*hyd.H axis=3 space=n | ${WinD} | ${TpowD} | ${WigglD} title="Hydrophone" plotcol=${yel} out=$@-hyd-w1.v pclip=94 > ${dn}
	Merge ${D}/node$*hyd.H ${D}/desig-node$*hyd.H axis=3 space=n | ${WinD} | ${TpowD} | ${WigglD} title="Hydrophone" plotcol=${cya} out=$@-hyd-w2.v pclip=94 poly=n > ${dn}
	vppen < $@-hyd-w1.v out0=$@-hydb.v out1=${dn}     vpstyle=n
	vppen < $@-hyd-w2.v out0=${dn}     out1=$@-hyda.v vpstyle=n
	vp_Overlay $@-hydb.v $@-hyda.v > $@-hyd.v
	rm $@-hyd-w[12].v $@-hyd[ab].v

	Merge ${D}/node$*vz.H ${D}/desig-node$*vz.H axis=3 space=n   | Spectra | Stack | Window3d max1=15 | Log | ${GraphD} title="Vertical geophone" curvelabel="node $* Vz before desig:node $* Vz after desig" out=$@-vz-f1.v > ${dn}
	Merge ${D}/node$*vz.H ${D}/desig-node$*vz.H axis=3 space=n | ${WinD} | ${TpowD} | ${WigglD} title="Vertical geophone" plotcol=${yel} out=$@-vz-w1.v pclip=91 > ${dn}
	Merge ${D}/node$*vz.H ${D}/desig-node$*vz.H axis=3 space=n | ${WinD} | ${TpowD} | ${WigglD} title="Vertical geophone" plotcol=${cya} out=$@-vz-w2.v pclip=91 poly=n > ${dn}
	vppen < $@-vz-w1.v out0=$@-vzb.v out1=${dn}    vpstyle=n
	vppen < $@-vz-w2.v out0=${dn}    out1=$@-vza.v vpstyle=n
	vp_Overlay $@-vzb.v $@-vza.v > $@-vz.v
	rm $@-vz-w[12].v $@-vz[ab].v

	Merge ${D}/node$*vx.H ${D}/desig-node$*vx.H axis=3 space=n   | Spectra | Stack | Window3d max1=15 | Log | ${GraphD} title="Horizontal X geophone" curvelabel="node $* Vx before desig:node $* Vx after desig" out=$@-vx-f1.v > ${dn}
	Merge ${D}/node$*vx.H ${D}/desig-node$*vx.H axis=3 space=n | ${WinD} | ${TpowD} | ${WigglD} title="Horizontal X geophone" plotcol=${yel} out=$@-vx-w1.v pclip=93 > ${dn}
	Merge ${D}/node$*vx.H ${D}/desig-node$*vx.H axis=3 space=n | ${WinD} | ${TpowD} | ${WigglD} title="Horizontal X geophone" plotcol=${cya} out=$@-vx-w2.v pclip=93 poly=n > ${dn}
	vppen < $@-vx-w1.v out0=$@-vxb.v out1=${dn}    vpstyle=n
	vppen < $@-vx-w2.v out0=${dn}    out1=$@-vxa.v vpstyle=n
	vp_Overlay $@-vxb.v $@-vxa.v > $@-vx.v
	rm $@-vx-w[12].v $@-vx[ab].v

	Merge ${D}/node$*vy.H ${D}/desig-node$*vy.H axis=3 space=n   | Spectra | Stack | Window3d max1=15 | Log | ${GraphD} title="Horizontal Y geophone" curvelabel="node $* Vy before desig:node $* Vy after desig" out=$@-vy-f1.v > ${dn}
	Merge ${D}/node$*vy.H ${D}/desig-node$*vy.H axis=3 space=n | ${WinD} | ${TpowD} | ${WigglD} title="Horizontal Y geophone" plotcol=${yel} out=$@-vy-w1.v pclip=93 > ${dn}
	Merge ${D}/node$*vy.H ${D}/desig-node$*vy.H axis=3 space=n | ${WinD} | ${TpowD} | ${WigglD} title="Horizontal Y geophone" plotcol=${cya} out=$@-vy-w2.v pclip=93 poly=n > ${dn}
	vppen < $@-vy-w1.v out0=$@-vyb.v out1=${dn}    vpstyle=n
	vppen < $@-vy-w2.v out0=${dn}    out1=$@-vya.v vpstyle=n
	vp_Overlay $@-vyb.v $@-vya.v > $@-vy.v
	rm $@-vy-w[12].v $@-vy[ab].v

${R}/CA-sig: ${D}/CA_Hyd.H ${D}/CA_Geo.H
	Merge $^ axis=2 space=n | Window min1=-0.05 max1=0.05 | ${Graph2} legend=y legendloc=tl curvelabel="Hydrophone signature:Geophone signature" out=$@.v > ${dn}
	Merge $^ axis=2 space=n | Spectra | Log | Window max1=15 | ${Graph2} label1="Frequency (Hz)" label2="Log amplitude" legend=y legendloc=br curvelabel="Hydrophone response spectrum:Geophone response spectrum" out=$@f.v > ${dn}
	

desig:
	make ${R}/CA-sig
	make ${R}/CA-sig.pdf ${R}/CA-sigf.pdf
	make ${R}/comp-node1300
	make ${R}/comp-node1300-hyd-f1.pdf ${R}/comp-node1300-hyd.pdf
	make ${R}/comp-node1300-vz-f1.pdf ${R}/comp-node1300-vz.pdf
	make ${R}/comp-node1300-vx-f1.pdf ${R}/comp-node1300-vx.pdf
	make ${R}/comp-node1300-vy-f1.pdf ${R}/comp-node1300-vy.pdf

#=======================================
# test designature on a spike
${D}/desigtest.H: ${D}/CA_Geo.H ${B}/desig_c2c.x
	cp ${D}/CA_Geo.H ${D}/sig.H
	echo "hff=-1" >> ${D}/sig.H
	Spike n1=8000 d1=0.001 k1=4000 > ${D}/spike.H
	Rtoc < ${D}/sig.H   | Pad n1out=0 | Ft3d sign1=-1 center1=0 > ${D}/fsig.H
	Rtoc < ${D}/spike.H | Pad n1out=0 | Ft3d sign1=-1 center1=0 > ${D}/fspike.H
	Math file1=${D}/fsig.H file2=${D}/fspike.H exp_real='file1.re*file2.re-file1.im*file2.im' exp_imag='file1.re*file2.im+file1.im*file2.re' > ${D}/fconv.H
	Ft3d < ${D}/fconv.H sign1=1 center1=1 | Real | Pad beg1=97 | Window n1=8000 | Scale rscale=90.5 > ${D}/conv.H
	echo "o1=-4" >> ${D}/conv.H
	${B}/desig_c2c.x < ${D}/conv.H sig=${D}/sig.H delt=0.1 eps=5.7e-1 taper=${D}/taper.H amp=${D}/amp.H fsig=${D}/fsig.H > $@
	Merge ${D}/spike.H ${D}/desigtest.H axis=2 space=n | Window min1=3.9 max1=4.1 | Graph | Tube &


#==============================
# test nearest offset first break amplitudes
#==============================
${D}/hyd-nearoff: ${D}/microspread6.H
	Window_key < $< key1=Offsetx mink1=-0.01 maxk1=0.01 key2=Tracf mink2=4 maxk2=4 synch=1 1> $@.H hff=$@.H@@ 2>${dn}
	Window3d < $@.H min1=1. n1=200 > $@-win.H hff=$@-win.H@@
	Rm $@-win.H@@
	echo "hff=-1" >> $@-win.H
	Graph < $@-win.H | Tube &
	Stack < $@-win.H axes=2 normalize=y | Stack axes=1 normalize=y > $@-tot.H
	Attr < $@-tot.H

${D}/vz-nearoff: ${D}/microspread6.H
	Window_key < $< key1=Offsetx mink1=-0.01 maxk1=0.01 key2=Tracf mink2=3 maxk2=3 synch=1 1> $@.H hff=$@.H@@ 2>${dn}
	Window3d < $@.H min1=1. n1=200 > $@-win.H hff=$@-win.H@@
	Rm $@-win.H@@
	echo "hff=-1" >> $@-win.H
	Graph < $@-win.H | Tube &
	Stack < $@-win.H axes=2 normalize=y | Stack axes=1 normalize=y > $@-tot.H
	Attr < $@-tot.H



