Win6c   = Window3d min1=1.75 max1=5 min2=0. max2=8
Grey6c  = Grey color=I labelsz=6 titlesz=7 label1="Time (sec)" label2="Offset (km)" wantscalebar=y newclip=1 screenwd=9.
Grey6cf = Grey color=j labelsz=6 titlesz=7 label1="Time (sec)" label2="Offset (km)" wantscalebar=y newclip=1
BP6c    = Bandpass flo=4 fhi=90 phase=1
FK = Pad n1out=0 n2out=0 | Rtoc | Ft3d sign1=-1 sign2=-1 center1=1 center2=1 | Cabs


# select the hydrophone component from the rotated receiver gathers.
${D}/vol-node%-hyd.H: ${D}/rot-node%.H
	Window_key < $< key1=Sailline mink1=2001 maxk1=2001 key2=Tracf mink2=4. maxk2=4. synch=1 1> tmp$*.H 2>${dn}
	Sort3d     < tmp$*.H nkeys=1 key1=Offsetx ng1=${noffsetx1} og1=${ooffsetx1} dg1=${doffsetx1} > tmp$*-sort.H
	Infill3d   < tmp$*-sort.H normalize=y | ${BP6c} > $@
	Rm tmp$*.H tmp$*-sort.H
	

# select the vz component from the rotated receiver gathers.
${D}/vol-node%-vz.H: ${D}/rot-node%.H
	Window_key < $< key1=Sailline mink1=2001 maxk1=2001 key2=Tracf mink2=3. maxk2=3. synch=1 1> tmp$*.H 2>${dn}
	Sort3d     < tmp$*.H nkeys=1 key1=Offsetx ng1=${noffsetx1} og1=${ooffsetx1} dg1=${doffsetx1} > tmp$*-sort.H
	Infill3d   < tmp$*-sort.H normalize=y | ${BP6c} > $@
	Rm tmp$*.H tmp$*-sort.H

# select the vx component from the rotated receiver gathers.
${D}/vol-node%-vx.H: ${D}/rot-node%.H
	Window_key < $< key1=Sailline mink1=2001 maxk1=2001 key2=Tracf mink2=1. maxk2=1. synch=1 1> tmp$*.H 2>${dn}
	Sort3d     < tmp$*.H nkeys=1 key1=Offsetx ng1=${noffsetx1} og1=${ooffsetx1} dg1=${doffsetx1} > tmp$*-sort.H
	Infill3d   < tmp$*-sort.H normalize=y | ${BP6c} > $@
	Rm tmp$*.H tmp$*-sort.H

# select the vy component from the rotated receiver gathers.
${D}/vol-node%-vy.H: ${D}/rot-node%.H
	Window_key < $< key1=Sailline mink1=2001 maxk1=2001 key2=Tracf mink2=2. maxk2=2. synch=1 1> tmp$*.H 2>${dn}
	Sort3d     < tmp$*.H nkeys=1 key1=Offsetx ng1=${noffsetx1} og1=${ooffsetx1} dg1=${doffsetx1} > tmp$*-sort.H
	Infill3d   < tmp$*-sort.H normalize=y | ${BP6c} > $@
	Rm tmp$*.H tmp$*-sort.H

# GENERATE ROTATION DATA BY GEOPHONE DIFFERENCING
#
# after manipulation of the horizontal geophone polarities of the southern array (generation of dat/microspread6.H),
# and after rotation to survey coordinates (generation of dat/microspread7-rot.H),
# the X component points positive east and the Y component points positive north, and Z is down.
# Assuming we use right hand rule, the curl must also point north, and the roll must also point east, and the yaw must point down.
#
# To retain consistency for the pitch component (ry=-dx(vz)) we difference the nodes: -(east-west)/2m = (west-east)/2m.
# The position for the pitch component is taken as the western node from the pair being differenced.
#
# To retain consistency for the roll component (rx=dy(vz)) we subtract: (north-south)/1.9m.
# The position for the roll component is taken as the southern node from the pair being differenced.
#
# To retain consistency for the yaw component (rz=dx(vy)-dy(vx)), we subtract ((west-east)/2m - (north-south)/1.9m)

#=================== Microspread node arrangement by node numbers ==============================================
#      ^
# N    |  1300    1772    1482    1198     1688    1360    1257    1496    1437    1382    1535    1517     1587
# o    | 
# r    |
# t    |  1730    1188    1254    1328     1049    1020    1716    1432    1031    1653    1702    1522     1638
# h    |
# (+Y) |
#      -----> East (+X)
#===============================================================================================================

# pitch: west-east
${D}/vol-node1730-ry.H: ${D}/vol-node1188-vz.H ${D}/vol-node1730-vz.H
	Add scale=0.5,-0.5 ${D}/vol-node1730-vz.H ${D}/vol-node1188-vz.H > $@

${D}/vol-node1300-ry.H: ${D}/vol-node1772-vz.H ${D}/vol-node1300-vz.H
	Add scale=0.5,-0.5 ${D}/vol-node1300-vz.H ${D}/vol-node1772-vz.H > $@

# roll: north-south
${D}/vol-node1730-rx.H: ${D}/vol-node1300-vz.H ${D}/vol-node1730-vz.H
	Add scale=0.52,-0.52 ${D}/vol-node1300-vz.H ${D}/vol-node1730-vz.H > $@

${D}/vol-node1188-rx.H: ${D}/vol-node1772-vz.H ${D}/vol-node1188-vz.H
	Add scale=0.52,-0.52 ${D}/vol-node1772-vz.H ${D}/vol-node1188-vz.H > $@

# yaw: west-east (vy) and north-south (vx)
# we take the average of the derivatives between station pairs 1300,1772 and 1730,1188, so the position of the yaw data is in the "center" between these stations, staggered-grid style.
${D}/vol-node1730-rz.H: ${D}/vol-node1300-vy.H ${D}/vol-node1772-vy.H ${D}/vol-node1730-vy.H ${D}/vol-node1188-vy.H ${D}/vol-node1300-vx.H ${D}/vol-node1772-vx.H ${D}/vol-node1730-vx.H ${D}/vol-node1188-vx.H
	Add scale=0.5,-0.5 ${D}/vol-node1730-vy.H ${D}/vol-node1188-vy.H > ${D}/we1.H
	Add scale=0.5,-0.5 ${D}/vol-node1300-vy.H ${D}/vol-node1772-vy.H > ${D}/we2.H
	Add scale=0.5,0.5 ${D}/we1.H ${D}/we2.H > ${D}/we3.H

	Add scale=0.52,-0.52 ${D}/vol-node1300-vx.H ${D}/vol-node1730-vx.H > ${D}/ns1.H
	Add scale=0.52,-0.52 ${D}/vol-node1772-vx.H ${D}/vol-node1188-vx.H > ${D}/ns2.H
	Add scale=0.5,0.5 ${D}/ns1.H ${D}/ns2.H > ${D}/ns3.H

	# For the Yaw component, we need to multiply the difference by 1/2, as per the equation for curl.
	Add scale=1,-1 ${D}/we3.H ${D}/ns3.H | Scale rscale=0.5 > $@

	Rm ${D}/we[123].H ${D}/ns[123].H


# GENERATE PRESSURE GRADIENT DATA

# Inline pressure gradient, positive east: east-west
${D}/vol-node1730-px.H: ${D}/vol-node1188-hyd.H ${D}/vol-node1730-hyd.H
	Add scale=0.5,-0.5 ${D}/vol-node1188-hyd.H ${D}/vol-node1730-hyd.H > $@

# Crossline pressure gradient positive north: north-south
${D}/vol-node1730-py.H: ${D}/vol-node1300-hyd.H ${D}/vol-node1730-hyd.H
	Add scale=0.5,-0.5 ${D}/vol-node1300-hyd.H ${D}/vol-node1730-hyd.H > $@


#===================
# six-component figures: particle velocity and rotation
#===================
${R}/6c-node%: ${D}/vol-node%-vz.H ${D}/vol-node%-vx.H ${D}/vol-node%-vy.H ${D}/vol-node%-rz.H ${D}/vol-node%-rx.H ${D}/vol-node%-ry.H
	Merge < ${D}/vol-node$*-vz.H ${D}/vol-node$*-vx.H ${D}/vol-node$*-vy.H axis=3 space=n | ${Win6c} | Scale rscale=1e-3 | ${Grey6c} barlabel="mm/s"   titles="Vz:Vx:Vy" out=${R}/tmpv.v > ${dn}
	Merge < ${D}/vol-node$*-rz.H ${D}/vol-node$*-rx.H ${D}/vol-node$*-ry.H axis=3 space=n | ${Win6c} | Scale rscale=1e-3 | ${Grey6c} barlabel="mrad/s" titles="Rz:Rx:Ry" out=${R}/tmpr.v > ${dn}
	Merge < ${D}/vol-node$*-vz.H ${D}/vol-node$*-vx.H ${D}/vol-node$*-vy.H axis=3 space=n | ${Win6c} | Scale rscale=1e-3 | ${FK} | Window min1=0 max1=60 | ${Grey6cf} barlabel=" " out=${R}/tmpvf.v > ${dn}
	Merge < ${D}/vol-node$*-rz.H ${D}/vol-node$*-rx.H ${D}/vol-node$*-ry.H axis=3 space=n | ${Win6c} | Scale rscale=1e-3 | ${FK} | Window min1=0 max1=60 | ${Grey6cf} barlabel=" " out=${R}/tmprf.v > ${dn}
	vppen < ${R}/tmpv.v out0=$@-vz.v out1=$@-vx.v out2=$@-vy.v vpstyle=n
	vppen < ${R}/tmpr.v out0=$@-rz.v out1=$@-rx.v out2=$@-ry.v vpstyle=n
	vppen < ${R}/tmpvf.v out0=$@-vzf.v out1=$@-vxf.v out2=$@-vyf.v vpstyle=n
	vppen < ${R}/tmprf.v out0=$@-rzf.v out1=$@-rxf.v out2=$@-ryf.v vpstyle=n
	rm ${R}/tmp[rv]*.v

#===================
# pressure and pressure gradient figures
#===================
${R}/vol-node%-hyd.v: ${D}/vol-node%-hyd.H
	< $< ${Win6c} | Scale rscale=1e-3 | ${Grey6c} epclip=99 bpclip=1 barlabel="mbar" title="Pressure" out=$@ > ${dn}

${R}/pg-node%: ${D}/vol-node%-hyd.H	${D}/vol-node%-px.H ${D}/vol-node%-py.H
	Merge < ${D}/vol-node$*-px.H ${D}/vol-node$*-py.H axis=3 space=n | ${Win6c} | Scale rscale=1e-3 | ${Grey6c} epclip=98 bpclip=2  barlabel="mbar/m" titles="Px:Py" out=${R}/tmpp.v > ${dn}
	vppen < ${R}/tmpp.v out0=$@-px.v out1=$@-py.v vpstyle=n


genrot: ${R}/6c-node1730
	make ${R}/6c-node1730-vz.pdf   ${R}/6c-node1730-vx.pdf ${R}/6c-node1730-vy.pdf
	make ${R}/6c-node1730-rz.pdf   ${R}/6c-node1730-rx.pdf ${R}/6c-node1730-ry.pdf

genp: ${R}/pg-node1730 ${R}/vol-node1730-hyd.v
	make ${R}/vol-node1730-hyd.pdf ${R}/pg-node1730-px.pdf ${R}/pg-node1730-py.pdf


