
WinFB = Window3d min1=1.04 max1=1.14

# sort the microspread
${D}/microspread7-sort.H: ${D}/microspread7.H
	Sort3d < $< nkeys=4 \
	key1=Tracf		ng1=${ntracf}	og1=${otracf}	dg1=${dtracf} \
	key2=Nodeid		ng2=${nnode}	og2=${onode}	dg2=${dnode} \
	key3=Sx			ng3=${nsx}		og3=${osx}		dg3=${dsx} \
	key4=Sailline	ng4=${nsail}	og4=${osail}	dg4=${dsail} \
	> $@ hff=$@@@ gff=$@@@@@ # <--- sorted by sail-line / shot x / node id / component id
	echo "gff=-1" >> $@
	Rm $@@@@@


# Window out sail line #2001
${D}/microspread7-sail1.H: ${D}/microspread7.H
	Window_key < $< key1=Sailline mink1=2000.5 maxk1=2001.5 synch=1 1> $@ hff=$@@@ 2>${dn}

# sort the microspread's sail line #2001
${D}/microspread7-sail1-sort.H: ${D}/microspread7-sail1.H
	Sort3d < $< nkeys=3 \
	key1=Tracf		ng1=${ntracf}	og1=${otracf}	dg1=${dtracf} \
	key2=Nodeid		ng2=${nnode}	og2=${onode}	dg2=${dnode} \
	key3=Sx			ng3=${nsx1}		og3=${osx1}		dg3=${dsx1} \
	> $@ hff=$@@@ gff=$@@@@@ # <--- sorted by shot x (slow axis) / node number / component id (fast axis)
	echo "gff=-1" >> $@
	Rm $@@@@@


# show node rotations with HMO for sail line #2001
${D}/hmo-sail%.H: ${D}/microspread7-sail%-sort.H ${B}/hmo3d.x
	${B}/hmo3d.x < $< sdepth=${sdepth} vel=${water_vel} maxsize=1000000 > $@ hff=$@@@

${D}/fhi-hmo-sail%.H: ${D}/hmo-sail%.H
	< $< ${WinFB} | Bandpass flo=5 > $@ hff=$@@@

${D}/hrot-node%-sail1.H: ${D}/fhi-hmo-sail1.H ${B}/find_rotation.x
	${B}/find_rotation.x < $< nodeid=$* \
	osrc=${osx1} dsrc=${dsx1} nsrc=${nsx1_true} \
	oang=-90. dang=1. nang=181 \
	minoff=1 maxoff=5 \
	maxsize=1000000 \
	verb=0 > $@

${D}/hrot2-node%-sail1.H: ${D}/fhi-hmo-sail1.H ${B}/find_rotation2.x
	${B}/find_rotation2.x < $< nodeid=$* \
	osrc=${osx1} dsrc=${dsx1} nsrc=${nsx1_true} \
	oang=-90. dang=1. nang=181 \
	minoff=0 maxoff=50 \
	verb=0 > $@


# figures of amplitude of horizontal components vs angle of rotation
hGraphrot = Graph label1="angle (deg)" label2="average of first break amplitude" grid=n plotfat=5

${R}/hrot2-node%-sail1: ${D}/hrot2-node%-sail1.H
	Window3d < $< max2=8 n4=1 f4=0 | Grey newclip=1 color=IC title="node $* Vx rotations" label2="Source X (Km)" label1="Time (sec)" out=$@-vx.v > ${dn}
	Window3d < $< max2=8 n4=1 f4=1 | Grey newclip=1 color=IC title="node $* Vy rotations" label2="Source X (Km)" label1="Time (sec)" out=$@-vy.v > ${dn}

${R}/hrot-allnode-sail1: ${D}/hrot-node1020-sail1.H ${D}/hrot-node1031-sail1.H ${D}/hrot-node1049-sail1.H ${D}/hrot-node1188-sail1.H ${D}/hrot-node1198-sail1.H ${D}/hrot-node1254-sail1.H ${D}/hrot-node1257-sail1.H ${D}/hrot-node1300-sail1.H ${D}/hrot-node1328-sail1.H ${D}/hrot-node1360-sail1.H ${D}/hrot-node1382-sail1.H ${D}/hrot-node1432-sail1.H ${D}/hrot-node1437-sail1.H ${D}/hrot-node1482-sail1.H ${D}/hrot-node1496-sail1.H ${D}/hrot-node1517-sail1.H ${D}/hrot-node1522-sail1.H ${D}/hrot-node1535-sail1.H ${D}/hrot-node1587-sail1.H ${D}/hrot-node1638-sail1.H ${D}/hrot-node1653-sail1.H ${D}/hrot-node1688-sail1.H ${D}/hrot-node1702-sail1.H ${D}/hrot-node1716-sail1.H ${D}/hrot-node1730-sail1.H ${D}/hrot-node1772-sail1.H
	Cat3d $^ axis=3 | Window3d n2=1 f2=0 > ${D}/$(@F)-vx.H
	Cat3d $^ axis=3 | Window3d n2=1 f2=1 > ${D}/$(@F)-vy.H
	< ${D}/$(@F)-vx.H ${hGraphrot} title="Vx component amplitude vs rotation" out=$@-vx.v > ${dn}
	< ${D}/$(@F)-vy.H ${hGraphrot} title="Vy component amplitude vs rotation" out=$@-vy.v > ${dn}
	vp_Movie $@-vx.v $@-vy.v > $@.v

	
#===============================
#
# find node rotation and rotate
#
#===============================

# apply HMO to entire dataset
${D}/microspread7-hmo.H: ${D}/microspread7-sort.H ${B}/hmo3d.x
	${B}/hmo3d.x < $< sdepth=${sdepth} vel=${water_vel} maxsize=1000000 > $@ hff=$@@@

${D}/microspread7-hmo-win.H: ${D}/microspread7-hmo.H
	< $< ${WinFB} > $@ hff=$@@@

# window out one node
${D}/hmo-node%.H: ${D}/microspread7-hmo-win.H
	Window_key < $< key1=Nodeid mink1=$* maxk1=$* 1> $@ hff=$@@@ synch=1 2>${dn}

# figure out by how much this node needs to be rotated so that Vy is minimal, and print out the angle to a parameter file
${P}/rot-par-node%.P: ${D}/hmo-node%.H ${B}/print_rotang.x
	${B}/print_rotang.x < $< nodeid=$* \
	nsrc=${nsx} \
	oang=-90. dang=1. nang=181 \
	minoff=1 maxoff=5 \
	verb=0 1> ${dn} 2> tmpang
	sed "s/= \+/=/g" < tmpang | tr -s ' ' | tr ' ' '\n' | grep "[a-z]" > $@
	@rm tmpang

${D}/orig-node%.H: ${D}/microspread7-sort.H
	Window_key < $< key1=Nodeid mink1=$* maxk1=$* 1> $@ hff=$@@@ synch=1 2>${dn}

# actually rotate the node according to the parameter file.
# IMPORTANT: This program assumes that the data are sorted by receiver gathers and then by components.
# Also, it assumes that the components are ordered so that the X horizontal geophone is ALWAYS one trace before the Y horizontal geophone
${D}/rot-node%.H: ${D}/orig-node%.H ${P}/rot-par-node%.P ${B}/rotate_vxvy.x
	${B}/rotate_vxvy.x < $< par=${P}/rot-par-node$*.P > $@ hff=$@@@
	

${D}/microspread7-rot.H: ${D}/rot-node1020.H ${D}/rot-node1031.H ${D}/rot-node1049.H ${D}/rot-node1188.H ${D}/rot-node1198.H ${D}/rot-node1254.H ${D}/rot-node1257.H ${D}/rot-node1300.H ${D}/rot-node1328.H ${D}/rot-node1360.H ${D}/rot-node1382.H ${D}/rot-node1432.H ${D}/rot-node1437.H ${D}/rot-node1482.H ${D}/rot-node1496.H ${D}/rot-node1517.H ${D}/rot-node1522.H ${D}/rot-node1535.H ${D}/rot-node1587.H ${D}/rot-node1638.H ${D}/rot-node1653.H ${D}/rot-node1688.H ${D}/rot-node1702.H ${D}/rot-node1716.H ${D}/rot-node1730.H ${D}/rot-node1772.H
	Merge ${D}/rot-node1020.H ${D}/rot-node1031.H ${D}/rot-node1049.H ${D}/rot-node1188.H ${D}/rot-node1198.H ${D}/rot-node1254.H ${D}/rot-node1257.H ${D}/rot-node1300.H ${D}/rot-node1328.H ${D}/rot-node1360.H ${D}/rot-node1382.H ${D}/rot-node1432.H ${D}/rot-node1437.H ${D}/rot-node1482.H ${D}/rot-node1496.H ${D}/rot-node1517.H ${D}/rot-node1522.H ${D}/rot-node1535.H ${D}/rot-node1587.H ${D}/rot-node1638.H ${D}/rot-node1653.H ${D}/rot-node1688.H ${D}/rot-node1702.H ${D}/rot-node1716.H ${D}/rot-node1730.H ${D}/rot-node1772.H space=n axis=2 > $@ 
	Merge ${D}/rot-node1020.H@@ ${D}/rot-node1031.H@@ ${D}/rot-node1049.H@@ ${D}/rot-node1188.H@@ ${D}/rot-node1198.H@@ ${D}/rot-node1254.H@@ ${D}/rot-node1257.H@@ ${D}/rot-node1300.H@@ ${D}/rot-node1328.H@@ ${D}/rot-node1360.H@@ ${D}/rot-node1382.H@@ ${D}/rot-node1432.H@@ ${D}/rot-node1437.H@@ ${D}/rot-node1482.H@@ ${D}/rot-node1496.H@@ ${D}/rot-node1517.H@@ ${D}/rot-node1522.H@@ ${D}/rot-node1535.H@@ ${D}/rot-node1587.H@@ ${D}/rot-node1638.H@@ ${D}/rot-node1653.H@@ ${D}/rot-node1688.H@@ ${D}/rot-node1702.H@@ ${D}/rot-node1716.H@@ ${D}/rot-node1730.H@@ ${D}/rot-node1772.H@@ space=n axis=2 > $@@@
	echo hff=$@@@ >> $@


# Figure of rotation results before/after HMO for a particular node

# window out vy of one node from rotated data
${D}/hmo-rot-node%-vy.H: ${D}/rot-node%.H ${B}/hmo3d.x
	${B}/hmo3d.x < ${D}/rot-node$*.H  sdepth=${sdepth} vel=${water_vel} maxsize=1000000 > rot-hnode$*.H
	Window_key   < rot-hnode$*.H key1=Sailline mink1=2001 maxk1=2001 key2=Tracf mink2=1.9 maxk2=2.1 synch=1 1> rot-hnode$*vy.H 2>${dn}
	Sort3d       < rot-hnode$*vy.H nkeys=1 key1=Offsetx ng1=${noffsetx1} og1=${ooffsetx1} dg1=${doffsetx1} > rot-hnode$*vysort.H
	Infill3d     < rot-hnode$*vysort.H normalize=y > $@
	Rm rot-hnode$*.H rot-hnode$*vy.H rot-hnode$*vysort.H

# window out vy of one node from unrotated data
${D}/hmo-orig-node%-vy.H: ${D}/orig-node%.H ${B}/hmo3d.x
	${B}/hmo3d.x < ${D}/orig-node$*.H sdepth=${sdepth} vel=${water_vel} maxsize=1000000 > hnode$*.H
	Window_key   < hnode$*.H key1=Sailline mink1=2001 maxk1=2001 key2=Tracf mink2=1.9 maxk2=2.1 synch=1 1> hnode$*vy.H    2>${dn}
	Sort3d       < hnode$*vy.H nkeys=1 key1=Offsetx ng1=${noffsetx1} og1=${ooffsetx1} dg1=${doffsetx1} > hnode$*vysort.H
	Infill3d     < hnode$*vysort.H normalize=y > $@
	Rm hnode$*.H hnode$*vy.H hnode$*vy.H hnode$*vysort.H

# window out vx of one node from rotated data
${D}/hmo-rot-node%-vx.H: ${D}/rot-node%.H ${B}/hmo3d.x
	${B}/hmo3d.x < ${D}/rot-node$*.H  sdepth=${sdepth} vel=${water_vel} maxsize=1000000 > rot-hnode$*.H
	Window_key   < rot-hnode$*.H key1=Sailline mink1=2001 maxk1=2001 key2=Tracf mink2=0.9 maxk2=1.1 synch=1 1> rot-hnode$*vx.H 2>${dn}
	Sort3d       < rot-hnode$*vx.H nkeys=1 key1=Offsetx ng1=${noffsetx1} og1=${ooffsetx1} dg1=${doffsetx1} > rot-hnode$*vxsort.H
	Infill3d     < rot-hnode$*vxsort.H normalize=y > $@
	Rm rot-hnode$*.H rot-hnode$*vx.H rot-hnode$*vxsort.H

# window out vx of one node from unrotated data
${D}/hmo-orig-node%-vx.H: ${D}/orig-node%.H ${B}/hmo3d.x
	${B}/hmo3d.x < ${D}/orig-node$*.H sdepth=${sdepth} vel=${water_vel} maxsize=1000000 > hnode$*.H
	Window_key   < hnode$*.H key1=Sailline mink1=2001 maxk1=2001 key2=Tracf mink2=0.9 maxk2=1.1 synch=1 1> hnode$*vx.H    2>${dn}
	Sort3d       < hnode$*vx.H nkeys=1 key1=Offsetx ng1=${noffsetx1} og1=${ooffsetx1} dg1=${doffsetx1} > hnode$*vxsort.H
	Infill3d     < hnode$*vxsort.H normalize=y > $@
	Rm hnode$*.H hnode$*vx.H hnode$*vx.H hnode$*vxsort.H


${R}/rotcomp-node%: ${D}/hmo-orig-node%.H ${D}/hmo-rot-node%.H
	Merge axis=3 space=n $^ |\
	Window3d min1=0.9 max1=1.5 min2=-10 max2=10 |\
	Grey title=" " label1="Time(sec)" label2="Offset (km)" color=IC out=$@.v > ${dn}
	vppen < $@.v out0=$@1.v out1=$@2.v vpstyle=n


rotfig: ${R}/hrot-allnode-sail1 ${R}/rotcomp-node1300-vy ${R}/rotcomp-node1300-vx
	make ${R}/hrot-allnode-sail1-vx.pdf ${R}/hrot-allnode-sail1-vy.pdf	
	make ${R}/rotcomp-node1300-vy1.pdf ${R}/rotcomp-node1300-vy2.pdf
	make ${R}/rotcomp-node1300-vx1.pdf ${R}/rotcomp-node1300-vx2.pdf


#headers = $(shell for file in `find ${D} -name \*.H`; do echo $$file; done)

#this:
#	@echo $(headers)
	
