#!/usr/bin/perl

# script to import Moere Vest data, acquired by Seabed Geosolutions
# 


use strict;
use warnings;

if ($#ARGV != 1) {
	print "usage: importdata.pl <source directory> <target directory>\n";
	exit (1);
}

my $sdir = $ARGV[0];
my $D = $ARGV[1];

#my $Cat3d = "/opt/SEP/SEP8.0/bin/Cat3d";
my $Cat3d = "cat";

my @files;

opendir (SDIR, $sdir) || die "error opening source file directory $sdir: $!";

while (my $segyfile = readdir (SDIR)) {
	#if ($segyfile =~ /^processed_long_2001100.*.segy$/) {
	if ($segyfile =~ /^shotdata_main_2001.*.segy$/) {
		push (@files, $segyfile);
	}
}

my @sorted = sort @files;
my @outfilesx;
my @outfilesy;

foreach my $f (@sorted) {
	if ($f =~ /^(\S+).segy/) {
		my $fname = $1;

		my $outfilex = "$D"."/"."$fname".".x";
		my $outfiley = "$D"."/"."$fname".".y";
		push (@outfilesx, $outfilex);
		push (@outfilesy, $outfiley);


		print   "dd if=$sdir/$f bs=1 skip=3780 count=4 | swapbytes in=int > $outfilex\n";
		print   "dd if=$sdir/$f bs=1 skip=3784 count=4 | swapbytes in=int > $outfiley\n";
		system ("dd if=$sdir/$f bs=1 skip=3780 count=4 | swapbytes in=int > $outfilex");
		system ("dd if=$sdir/$f bs=1 skip=3784 count=4 | swapbytes in=int > $outfiley");

	}
}

my $catfilex = "$D/recx";
my $catfiley = "$D/recy";
print   "$Cat3d @outfilesx | od -i -v --width=4 -A n > $catfilex\n";
print   "$Cat3d @outfilesy | od -i -v --width=4 -A n > $catfiley\n";
system ("$Cat3d @outfilesx | od -i -v --width=4 -A n > $catfilex");
system ("$Cat3d @outfilesy | od -i -v --width=4 -A n > $catfiley");
system ("paste $catfilex $catfiley > $D/recxy");
system ("rm @outfilesx");
system ("rm @outfilesy");




