#!/usr/bin/perl

# script to import Moere Vest data, acquired by Seabed Geosolutions
# 


use strict;
use warnings;

if ($#ARGV != 1) {
	print "usage: importdata.pl <source directory> <target directory>\n";
	exit (1);
}

my $sdir = $ARGV[0];
my $D = $ARGV[1];

my $Cat3d = "/opt/SEP/SEP8.0/bin/Cat3d";

my @files;

opendir (SDIR, $sdir) || die "error opening source file directory $sdir: $!";

while (my $segyfile = readdir (SDIR)) {
	#if ($segyfile =~ /^processed_long_2001100.*.segy$/) {
	if ($segyfile =~ /^shotdata_main_2001.*.segy$/) {
		push (@files, $segyfile);
	}
}

my @sorted = sort @files;
my @outfiles;

foreach my $f (@sorted) {
	if ($f =~ /^(\S+).segy/) {
		my $fname = $1;

		my $outfile = "$D"."/"."$fname".".H";
		push (@outfiles, $outfile);

		# convert segy to su.
		#print "segyread tape=$sdir/$f > $D/tmp.su\n";
		#system ("segyread tape=$sdir/$f > $D/tmp.su");

#		# convert segy to su, remap receiver positions as calculated from the first breaks to the 'swdep' and 'gwdep' field. swdep<=gx, gwdep<=gy.
		print "segyread tape=$sdir/$f remap=swdep,gwdep byte=181l,185l > $D/tmp.su\n";
		system ("segyread tape=$sdir/$f remap=swdep,gwdep byte=181l,185l > $D/tmp.su");
		system ("Su2sep < $D/tmp.su > $D/tmp.H hff=$D/tmp.H@@");
		system ("rm $D/tmp.su");

		my $cmd = "Headermath < $D/tmp.H key1=tracl type1=scalar_int eqn1=tracl+0 ";

		open (TESTKEY, "In $D/tmp.H | grep key | awk '{ print \$1 }' |");
		while (my $key = <TESTKEY>) {
			chomp ($key);
			if ($key =~ /^key14=gdel$/) {
				$cmd = "$cmd"."delete_keys=14";
			}
			if ($key =~ /^key25=swevel$/) {
				$cmd = "$cmd"."delete_keys=25";
			}
			if ($key =~ /^key26=swevel$/) {
				$cmd = "$cmd".",26";
			}
		}

		$cmd = "$cmd"." > $outfile hff=$outfile@@";

		print "$cmd\n";
		system ("$cmd");
		system ("rm $D/tmp.H");
		system ("Rm $D/tmp.H@@");

	}
}




my $catfile = "$D/microspread.H";
print   "$Cat3d @outfiles axis=3 > $catfile hff=$catfile@@\n";
system ("$Cat3d @outfiles axis=3 > $catfile hff=$catfile@@");
#system ("Rm @outfiles");

