#!/bin/sh

if [ $# -ne 2 ]; then
	echo "usage: <data directory> <scratch directory>"
	exit 1
fi

found=0
D=$1
S=$2

datfiles=`ls -1 $D | grep \.H`
scratchfiles=`ls -1 $S`

/bin/rm -f datfiles.out
touch datfiles.out

for d in $datfiles; do
	In ${D}/$d 2>/dev/null | grep in= | awk -F'in=' '{ print $2 }' >> datfiles.out
done


for f in $scratchfiles; do
	grep $f datfiles.out > /dev/null 2>&1
	if [ $? -ne $found ]; then
		echo "removing orphan scratch file ${S}/$f"
		/bin/rm ${S}/$f
	fi
done

