#!/usr/bin/perl

# script to import Moere Vest data, acquired by Seabed Geosolutions
# 


use strict;
use warnings;

if ($#ARGV != 1) {
	print "usage: importdata.pl <source directory> <target directory>\n";
	exit (1);
}

my $sdir = $ARGV[0];
my $D = $ARGV[1];

my $Cat3d = "/opt/SEP/SEP8.0/bin/Cat3d";

my @files;

opendir (SDIR, $sdir) || die "error opening source file directory $sdir: $!";

while (my $segyfile = readdir (SDIR)) {
	#if ($segyfile =~ /^processed_long_2001100.*.segy$/) {
	if ($segyfile =~ /^shotdata_main_2001.*.segy$/) {
		push (@files, $segyfile);
	}
}

my @sorted = sort @files;
my @outfiles;

foreach my $f (@sorted) {
	if ($f =~ /^(\S+).segy/) {
		my $fname = $1;

		my $outfile = "$D"."/"."$fname".".H";
		my $outkeyfile = "$D"."/"."$fname".".keys";
		push (@outfiles, $outfile);

		system ("In3d $outfile | grep key | awk '{ print \$1 }' > $outkeyfile");

		#print "segyread tape=$sdir/$f > $D/tmp.su\n";
		#system ("segyread tape=$sdir/$f > $D/tmp.su");
		#system ("Su2sep < $D/tmp.su > $outfile hff=$outfile@@");
		#system ("Su2sep < $D/tmp.su > $D/tmp.H hff=$D/tmp.H@@");
		#system ("rm $D/tmp.su");


	}
}

